; Cwiczenie nr 4 na laboratoria z Asemblerow
; (C) 2001 Marcin Owsiany
; Prosty program rezydentny
.286
.Model Tiny,Stdcall
.Code
JUMPS

Org 100h

start:
		jmp  installcode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; przerwanie kontrolne
nowe50:
; mamy za zadanie zwrocic 0864h jesli AX == 1357h
; w przeciwnym wypadku wywolujemy poprzednie 50h
		cmp  ax, 1357h
		jne  jmpstare50
		mov  ax, 0864h
		iret
jmpstare50:	db   0EAh	; opcode jmp near
stare50		dd   0		; tu bedzie wrzucony adres starego przerwania

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; obsluga klawiatury
nowe09:
		push ax
		in   al, 60h
		cmp  al, 185			; SPACE break code
		jne  noway
		push ax
		push es
		xor  ax, ax
		mov  es, ax
		test byte ptr es:[417h], 100b	; stan klawiatury: bit 2 == CTRL
		pop  es
		pop  ax
		jnz  thisisit

noway:		jmp  jmpstare09

thisisit:	cli
		pusha
		call play, 16
		call pause
		call silence
		call pause
		call play, 14
		call pause
		call silence
		call pause
		call play, 16
		call pause
		call silence
		call pause
		call play, 14
		call pause
		call silence
		call pause
		call play, 16
		call pause
		call silence
		call pause
		call play, 14
		call pause
		call silence
		call pause
		call play, 16
		call pause
		call silence
		call pause
		call play, 14
		call pause
		call silence
		call pause
		call play, 12
		call pause
		call pause
		call pause
		call pause
		call pause
		call pause
		call silence
		call play, 8
		call pause
		call silence
		call pause
		call play, 9
		call pause
		call silence
		call pause
		call play, 10
		call pause
		call silence
		call pause
		call play, 13
		call pause
		call pause
		call pause
		call silence
		call play, 8
		call pause
		call silence
		call pause
		call play, 9
		call pause
		call silence
		call pause
		call play, 10
		call pause
		call silence
		call pause
		call play, 14
		call pause
		call pause
		call pause
		call pause
		call pause
		call pause
		call silence
		popa
		sti
		mov  al, 20h
		out  20h, al
		pop  ax
		mov  cs:[was_ctrl], 0
		iret
		
jmpstare09:	pop ax
		db  0EAh	; opcode jmp near
stare09		dd  0		; tu bedzie wrzucony adres starego przerwania

was_ctrl	db  0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; pare procedur pomocniczych

play proc wysokosc:WORD
		mov  bx, wysokosc
		cmp  bx, 12h
		jnb  play_1
		mov  ax, 34DDh
		xor  dx, dx
		div  bx
		mov  bx, ax
		in   al, 61h
		test al, 03h
		jnz  play_2
		or   al, 03h
		out  61h, al
		mov  al, -4Ah
		out  43h, al
play_2:		mov  al, bl
		out  42h, al
		mov  al, bh
		out  42h, al
play_1:		ret
play endp

silence proc
		in   al,  61h
		and  al,  0Fch
		out  61h, al
		ret
silence endp

pause proc
		mov  cx, 1
		mov  dx, 1
		mov  ah, 86h
		int  15h
		ret
pause endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
installcode:
; parametry programu
		xor  cx, cx
		mov  cl, es:[80h]
		cmp  cx, 0
		je   install
		cmp  cx, 3
		je   chku
badusage:	mov  dx, offset helptxt
		call helpmsg
chku:		mov  cx, es:[82h]
		cmp  cl, '-'
		jne  badusage
		mov  cx, es:[83h]
		cmp  cl, 'u'
		jne  badusage
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; kod deinstalacji
uninstall:	mov  dx, offset msguninstall
		call debugmsg
; sprawdzamy, czy program jest zainstalowany
		mov  ax, 1357h				; magic cookie :-)
		int  50h
		cmp  ax, 0864h
		je   dok_go_on
		mov  dx, offset msgnotinstalled
		call helpmsg

; odtwarzamy stare wektory przerwan
dok_go_on:	mov  ax, 3550h
		int  21h
		push es				; bedzie male zamieszanie
		mov  ax, word ptr es:[offset stare50+2]
		mov  ds, ax
		mov  dx, word ptr es:[offset stare50]
		mov  ax, 2550h
		int  21h
		pop  es
		push es
		mov  ax, word ptr es:[offset stare09+2]
		mov  ds, ax
		mov  dx, word ptr es:[offset stare09]
		mov  ax, 2509h
		int  21h
		pop  es

		mov  ah, 49h			; zwalniamy segment
		int  21h
		mov  ax, 4c00h
		int  21h

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; kod instalacji
install:	mov  dx, offset msginstall
		call debugmsg

; sprawdzamy, czy program nie jest juz zainstalowany
		mov  ax, 1357h				; magic cookie :-)
		int  50h
		cmp  ax, 0864h
		jne  ok_go_on
		mov  dx, offset msginstalled
		call helpmsg

ok_go_on:
; zwolnienie segmentu srodowiska, aby TSR zajmowal mniej miejsca
		mov  ax, word ptr cs:[2ch]		; jego numer jest pod
		mov  es, ax				; offsetem 2ch w PSP
		mov  ah, 49h
		int  21h
		jnc  ok_go_on2
		mov  dx, offset errenvseg
		call helpmsg

ok_go_on2:
		mov  ax, 50h				; przerwanie kontrolne
		mov  ah, 35h				; pobranie wertora
		int  21h
		mov  di, offset stare50
		mov  word ptr cs:[di], bx
		mov  bx, es
		mov  word ptr cs:[di+2], bx

		mov  ax, 09h				; przerwanie klawiatury
		mov  ah, 35h				; pobranie wertora
		int  21h
		mov  di, offset stare09
		mov  word ptr cs:[di], bx
		mov  bx, es
		mov  word ptr cs:[di+2], bx

		mov  ax, cs
		mov  ds, ax
		mov  ax, 50h				; przerwanie kontrolne
		mov  ah, 25h				; ustawienie wektora
		mov  dx, offset nowe50
		int  21h

		mov  ax, cs
		mov  ds, ax
		mov  ax, 09h				; przerwanie klawiatury
		mov  ah, 25h				; ustawienie wektora
		mov  dx, offset nowe09
		int  21h

finish:		mov  dx, offset installcode	; usuwamy kod instalacji/deinstalacji
		int  27h			; zostawiamy reszte
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; wypisuje string wskazywany przez dx
write proc
		push ax
		mov  ah, 9
		int  21h
		pop  ax
		ret
write endp

; wypisuje string wskazywany przez bx o dlugosci w cx
mywrite proc
		push ax
		push si
		push dx
		mov  ah, 2
		xor  si, si
mwl:		mov  dl, ds:[bx+si]
		int  21h
		inc  si
		loop mwl
		pop  dx
		pop  si
		pop  ax
		ret
mywrite endp

; pomoc - ustaw dx na komunikat bledu
helpmsg proc
		push dx
		mov  dx, offset endl
		call write
		pop  dx
		call write
		mov  dx, offset endl
		call write
		mov  ah, 4ch
		mov  al, 1
		int  21h
helpmsg endp

; informacja - ustaw dx na komunikat
debugmsg proc
		call write
		mov  dx, offset endl
		call write
		ret
debugmsg endp

	helptxt		db "Uzycie programu: r [-u]$"
	msginstall	db "Instalowanie...$"
	msguninstall	db "Odinstalowywanie...$"
	msginstalled	db "Program juz jest zainstalowany!$"
	msgnotinstalled	db "Program nie jest zainstalowany!$"
	endl		db '', 13, 10, '$'		; CL+LF
	errenvseg	db "Nie udalo sie zwolnic segmentu srodowiska.$"
	msgunloaded	db "Program zostal usuniety z pamieci.$"

end start
